Package: geneXtendeR
Type: Package
Version: 1.36.0
Title: Optimized Functional Annotation Of ChIP-seq Data
Description: geneXtendeR optimizes the functional annotation of ChIP-seq peaks by exploring relative differences in annotating ChIP-seq peak sets to variable-length gene bodies.  In contrast to prior techniques, geneXtendeR considers peak annotations beyond just the closest gene, allowing users to see peak summary statistics for the first-closest gene, second-closest gene, ..., n-closest gene whilst ranking the output according to biologically relevant events and iteratively comparing the fidelity of peak-to-gene overlap across a user-defined range of upstream and downstream extensions on the original boundaries of each gene's coordinates.  Since different ChIP-seq peak callers produce different differentially enriched peaks with a large variance in peak length distribution and total peak count, annotating peak lists with their nearest genes can often be a noisy process.  As such, the goal of geneXtendeR is to robustly link differentially enriched peaks with their respective genes, thereby aiding experimental follow-up and validation in designing primers for a set of prospective gene candidates during qPCR.
Authors@R: c(
        person("Bohdan", "Khomtchouk", email = "khomtchoukmed@gmail.com", role = c("aut", "cre")), 
        person("William", "Koehler", email = "williamk03hler@gmail.com", role = c("aut"))
            )
Maintainer: Bohdan Khomtchouk <khomtchoukmed@gmail.com>
URL: https://github.com/Bohdan-Khomtchouk/geneXtendeR
BugReports: https://github.com/Bohdan-Khomtchouk/geneXtendeR/issues
Depends: rtracklayer, GO.db, R (>= 3.5.0)
Imports: data.table, dplyr, graphics, networkD3, RColorBrewer,
        SnowballC, tm, utils, wordcloud, AnnotationDbi, BiocStyle,
        org.Rn.eg.db
Suggests: knitr, rmarkdown, testthat, org.Ag.eg.db, org.Bt.eg.db,
        org.Ce.eg.db, org.Cf.eg.db, org.Dm.eg.db, org.Dr.eg.db,
        org.Gg.eg.db, org.Hs.eg.db, org.Mm.eg.db, org.Pt.eg.db,
        org.Sc.sgd.db, org.Ss.eg.db, org.Xl.eg.db, rtracklayer
VignetteBuilder: knitr
License: GPL (>= 3)
LazyData: TRUE
biocViews: ChIPSeq, Genetics, Annotation, GenomeAnnotation,
        DifferentialPeakCalling, Coverage, PeakDetection, ChipOnChip,
        HistoneModification, DataImport, NaturalLanguageProcessing,
        Visualization, GO, Software
RoxygenNote: 6.1.0
NeedsCompilation: yes
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/geneXtendeR
git_branch: RELEASE_3_22
git_last_commit: d65d2af
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 04:06:56 UTC; biocbuild
Author: Bohdan Khomtchouk [aut, cre],
  William Koehler [aut]

<div align="center">

# geneXtendeR

<img src="https://cloud.githubusercontent.com/assets/9893806/16898879/d14647c6-4bba-11e6-93d5-90bc802ac8e9.png">

##### R/Bioconductor package for optimized functional annotation of ChIP-seq data

![AUR](https://img.shields.io/aur/license/yaourt.svg)
[![Bioconductor Time](http://bioconductor.org/shields/years-in-bioc/geneXtendeR.svg)](http://bioconductor.org/packages/release/bioc/html/geneXtendeR.html "Bioconductor status")
<!-- [![Bioconductor Downloads](http://bioconductor.org/shields/downloads/geneXtendeR.svg)](https://bioconductor.org/packages/stats/bioc/geneXtendeR/ "Percentile downloads") -->

</div>

To see `geneXtendeR` in action (and why you may want to use it as part of your next ChIP-seq workflow), see Section 1 of the [vignette](https://github.com/Bohdan-Khomtchouk/geneXtendeR/tree/master/inst/doc). 

## Github installation instructions (for latest updated version)

You can install the current GitHub version using the [devtools](https://github.com/hadley/devtools) package:

```R
if (!require("devtools")) install.packages("devtools")
devtools::install_github("Bohdan-Khomtchouk/geneXtendeR")
```
And then load the package:

```R
library(geneXtendeR)
```

## Bioconductor landing page (updated biannually -- so likely out-of-date)

`geneXtendeR` can be found at: https://bioconductor.org/packages/geneXtendeR/.  This URL will redirect to the release landing page of the package and is the URL that should be used (in publications, etc.) to refer to `geneXtendeR`.  You can also refer specifically to the development, release, or specific numbered version of Bioconductor:

https://bioconductor.org/packages/devel/geneXtendeR/

https://bioconductor.org/packages/release/geneXtendeR/

https://bioconductor.org/packages/3.8/geneXtendeR/

## Bioconductor installation instructions

```R
## try http:// if https:// URLs are not supported
source("https://bioconductor.org/biocLite.R")
biocLite("geneXtendeR")
```

## Citation

Coming soon! 

#' Makes word cloud from gene ontology terms
#'
#' Creates word cloud from gene ontology terms derived from either biological process (BP), cellular compartment (CC), or molecular function (MF) of genes-under-peaks that are unique between two different upstream extension levels.
#'
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param GOcategory Either BP, CC, or MF.
#' @param GOspecies Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).  
#'
#' @return A word cloud comprised of words gathered from gene ontology terms of either a BP, CC, or MF category.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' library(tm)
#' library(SnowballC)
#' library(wordcloud)
#' library(RColorBrewer)
#' library(org.Rn.eg.db)
#' makeWordCloud(rat, 0, 500, BP, org.Rn.eg.db)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#' 
#' @importFrom tm VectorSource removeWords stopwords
#' @importFrom wordcloud wordcloud
#' @importFrom RColorBrewer brewer.pal
#' @importFrom GO.db GO.db
#'
#' @export
makeWordCloud <- function(organism, start, end, GOcategory, GOspecies) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    #oopts = options(warn=-1)
    #n.exit(options(oopts))
    
    run2 <- function(f1, f2, peakslist) {
      .C("extractpeaks", f1, f2, peakslist)[[3]]
    }
    
    sapply(c(start, end), .geneXtender, rat, FALSE)
    twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
    linelen <- ""  
    n <- 500000
    peaksArray <- rep(linelen, n)
    peaksArray2 <- rep(linelen, n)
    cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
    cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
    cmd1 <- cmdtmp1[cmdtmp1 != linelen]
    cmd2 <- cmdtmp2[cmdtmp2 != linelen]
    m = regexec("^(?:[^\t]+\t){3}", cmd1)
    first3.cmd1 = unlist(regmatches(cmd1, m))
    m = regexec("^(?:[^\t]+\t){3}", cmd2)
    first3.cmd2 = unlist(regmatches(cmd2, m))
    finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
    DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
    gene_names <- DT[[8]]
    
    if (deparse(substitute(GOcategory)) == 'BP') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'BP']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'CC') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'CC']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'MF') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'MF']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
      
    } else {
      stop("Not a valid GO category.  Must be either BP, CC, or MF.")
    }
    
  
  GO_terms <- uniq_symbol_GOID_terms$TERM
  GO_terms_corpus <- tm::Corpus(VectorSource(GO_terms))
  GO_terms_corpus <- tm::tm_map(GO_terms_corpus, removeWords, stopwords("english"))
  dtm <- tm::TermDocumentMatrix(GO_terms_corpus)
  doc_term_matrix <- as.matrix(dtm)
  v <- sort(rowSums(doc_term_matrix), decreasing = TRUE)
  d <- data.frame(word = names(v), freq = v)
  
  set.seed(1234)
  wordcloud(words = d$word, 
            freq = d$freq, 
            min.freq = 1, 
            max.words = 200, 
            random.order = FALSE, 
            rot.per = 0.35, 
            colors = brewer.pal(8, "Dark2"))
  
  }
}

context("makeWordCloud tester")
library(org.Rn.eg.db)

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

start <- 500
end <- 1500
GOspecies <- org.Rn.eg.db

test_that("correct message is thrown before peaksinput is run", {
  expect_message(makeWordCloud(rat, start, end, BP, GOspecies), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("error is thrown when not selecting correct category", {
  expect_error(makeWordCloud(rat, start, end, AP, GOspecies), "Not a valid GO category.  Must be either BP, CC, or MF.")
})

test_that("cleanup is successful for makeNetwork", {
  expect_silent(file.remove("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", c(start, end))))
})

#' Function for formatting data to be called by C function.
#'
#' Formats genome-data based on upstream and organism for .C caller function. Not to be run by user.
#' 
#' @param upstream Extension upstream of each gene.
#' @param organism Object name assigned from readGFF() command.
#' @param ret Logical that designates if the output is written in R or only as a .bed file
#'
#' @return The gene coordinates extended by the designated upstream. In .bed file format.
#' @return A data.table formatted version of the data depending on the ret logical.
#'
#' @note Not to be run by the user
#' 
#' 
#' @keywords internal
#' 
#' @import data.table
#'
#' @useDynLib geneXtendeR, .registration = TRUE
.geneXtender <- function(upstream, organism, ret = FALSE) {
  #oopts = options(warn=-1)
  #on.exit(options(oopts))
  messy2 <- dplyr::filter(organism, type == "gene")
  neat <- dplyr::select(messy2, seqid, start, end, strand, gene_id, gene_name)
  pos_exons <- dplyr::filter(neat, strand == "+")
  neg_exons <- dplyr::filter(neat, strand == "-")
  pos_exons$start = pos_exons$start - upstream
  pos_exons$start[pos_exons$start < 0] <- 1
  pos_exons$end = pos_exons$end + 500
  neg_exons$start = neg_exons$start - 500
  neg_exons$start[neg_exons$start < 0] <- 1
  neg_exons$end = neg_exons$end + upstream
  merged_exons <- rbind(pos_exons, neg_exons)
  geneXtender.file <- dplyr::select(merged_exons, seqid, start, end, gene_id, gene_name)
  levels(geneXtender.file$seqid) <- gsub("chr", "", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("CHR", "", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("X", "100", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("Y", "200", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("MT", "300", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("MtDNA", "300", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("M", "300", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("Mito", "300", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("I", "1", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("II", "2", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("III", "3", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("IV", "4", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("V", "5", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("VI", "6", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("VII", "7", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("VIII", "8", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("IX", "9", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XI", "11", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XII", "12", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XIII", "13", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XIV", "14", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XV", "15", levels(geneXtender.file$seqid))
  levels(geneXtender.file$seqid) <- gsub("XVI", "16", levels(geneXtender.file$seqid))
  geneXtender.file$seqid = as.numeric(as.character(geneXtender.file$seqid))
  geneXtender.sorted <- dplyr::arrange(geneXtender.file, as.numeric(seqid), start)
  write.table(geneXtender.sorted, quote = FALSE, sep = "\t", row.names = FALSE, col.names = FALSE, sprintf("geneXtender_gtf_%s.bed", upstream))
  if (ret == TRUE) {
    return(data.table::as.data.table(geneXtender.sorted))
  }
}

context("checking function gene_lookup")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

extension <- 1234
cutoff <- 0
n <- 5
gene_name <- "Vom2r3"

test_that("correct message is thrown before peaksinput is run", {
  expect_message(gene_lookup(rat, gene_name), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("user error handling", {
  expect_message(gene_lookup(rat, gene_name, n = 0, extension, cutoff), message = "Please select a cutoff >= 0 or a value of n >= 1")
})

test_that("gene_lookup works correctly", {
  expect_silent(p <- gene_lookup(rat, gene_name, n, extension))
  p <- gene_lookup(rat, gene_name, n, extension)
  expect_equal(dim(p), c(10, 7))
})

test_that("cutoff works properly", {
  expect_message(gene_lookup(rat, gene_name, n, extension, cutoff = -1), message = "Please select a cutoff >= 0 or a value of n >= 1")
  expect_silent(p <- gene_lookup(rat, gene_name, n, extension, cutoff))
  p <- gene_lookup(rat, gene_name, n, extension, cutoff)
  expect_equal(dim(p), c(0, 7))
})

test_that("File order is chosen properly", {
  .geneXtender(1235, rat, FALSE)
  .geneXtender(0, rat, FALSE)
  p <- gene_lookup(rat, gene_name, n)
  q <- gene_lookup(rat, gene_name, n, extension)
  expect_true(any(p != q, TRUE))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", c(1235, 0))))
})

test_that("cleanup is successful for gene_lookup", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", extension), "peaks.txt"))
})

context(".geneXtender checker") #hidden method

fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)

test_that("test dimensions and make sure it works", {
  expect_equal(dim(.geneXtender(2500, rat, TRUE)), c(32402, 5))
})

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

#' Annotate peaks file.
#'
#' Annotate a user's peaks file (which has been preprocessed with the peaksInput() command) with gene information based on optimally chosen geneXtendeR upstream extension file.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param extension Desired upstream extension.
#' @param n Number of Gene's closest away from the peak
#'
#' @return The gene coordinates are extended by `extension` at the 5-prime end, and by 500 bp at the 3-prime end.  The peaks file is then overlayed on these new gene coordinates, producing a file of peaks annotated with gene ID, gene name, and gene-to-peak genomic distance (in bp).  Distance is calculated between 5-prime end of gene and 3-prime end of peak. File named "annotated_'extension'_'n'.txt".
#' @return A data.table formatted version of the annotated file for checking or further calculations.
#'
#' @examples
#' \dontrun{
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' annotate_n(rat, 2500, n=3)
#' }
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
annotate_n <- function(organism, extension, n=2) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else if(n < 1) {
    message("Please run a valid distance of gene's away with n > 0")
  } else {
    oopts = options(warn=-1)
    on.exit(options(oopts))
    
    genes <- .geneXtender(extension, organism, TRUE)
    
    run3 <- function(f1, f2, peakslist) {
      .C("annotate", f1, f2, peakslist)[[3]]
    }
    linelen <- "                                                                                                                                                                                                                                                                                  "
    peaksArray<-rep(linelen,5000000)
    onegxFile <- sprintf("geneXtender_gtf_%s.bed", extension)
    onecmd2 <- run3(f1 = "peaks.txt", f2 = onegxFile, peakslist = peaksArray) 
    onecmd3 <- onecmd2[onecmd2 != linelen]
    
    rdt <- data.table::transpose(data.table::as.data.table(strsplit(onecmd3, "\t"))) #Formatting
    colnames(rdt) <- c("Chromosome", "Peak-Start", "Peak-End", "rm", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Distance-of-Gene-to-Nearest-Peak")
    rdt <- rdt[,rm:= NULL]
    for (j in c("Chromosome", "Peak-Start", "Peak-End", "Gene-Start", "Gene-End", "Distance-of-Gene-to-Nearest-Peak")) data.table::set(rdt, j=j, value = as.numeric(rdt[[j]]))

    
    #indexing
    indices <- sapply(rdt$`Gene-ID`, function(x) which(x == genes$gene_id))
    
    #error_checking (MORETODO)
    indices <- ifelse(indices < (n), n, indices)
    indices <- ifelse(indices > (length(genes$seqid) - (n-1)), length(genes$seqid) - (n-1), indices)
    rdt[,'bot' := (indices - (n-1))]
    rdt[,'top' := (indices + (n-1))]
    
    #THROW extras
    rdt[, c("Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Distance-of-Gene-to-Nearest-Peak") := NULL]
    
    #Grabs and adds
    rdt[, ..I := .I]
    some_fun <- function(dtx) {
      g <- genes[dtx$bot:dtx$top]
      g[,names(dtx) := dtx]
      return(g)
    }
    rdt <- rdt[, some_fun(.SD), by = ..I] #applies function by row
    rdt[, c('top', 'bot') := NULL] #Remove top and bot info
    
    es <- rdt$`Peak-End` - rdt$start
    se <- rdt$`Peak-Start` - rdt$end
    
    rdt[, "Minimum-Distance-to-Gene" := ifelse(between(0, pmin(es, se), pmax(es, se)), 0 ,pmin(abs(es), abs(se)))]
    
    setorderv(rdt, c("..I", "Minimum-Distance-to-Gene"))
    rdt[,rank := rep(1:(n*2-1), (.N/(n*2-1)))]
    rdt[rank <= n]
    
    
    data.table::setnames(rdt, c("start", "end", "gene_id", "gene_name", "..I"), c("Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Peak-Num"))
    data.table::setcolorder(rdt, c("Peak-Num", "Chromosome", "Peak-Start", "Peak-End", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "rank", "Minimum-Distance-to-Gene", "seqid"))
    
    #TODO more error handling (for now)
    err <- which(rdt$Chromosome != rdt$seqid)
    # if (length(err) > 0) {
    #   message(sprintf("Warning! There were %s peaks that could not find the next gene on their respective chromosomes %s genes away", length(err), n))
    #   #for(col in c("seqid", "start", "end", "gene_id", "gene_name")) set(export_table, i=err, j=col, value=NA) #cleanup
    # }
    rdt <- rdt[rank<= n]
    rdt <- rdt[,seqid := NULL]
    data.table::fwrite(
      rdt,
      file = sprintf("annotated_%s_%s.txt", extension, n),
      sep = "\t",
      row.names = FALSE,
      col.names = TRUE,
      quote = FALSE
    )
    return(rdt[])
  }
}

context("annotate_n checker")

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))
n <- 5
extension <- 1234

test_that("annotate_n is the correct length", {
  expect_silent(annotated <- annotate_n(rat, extension, n))
  annotated <- annotate_n(rat, extension, n)
  
  expect_equal(dim(annotated)[1], dim(samplepeaksinput)[1] * n)
  
  expect_equal(dim(annotated)[2], 10)
  
  expect_equal(names(annotated), c("Peak-Num", "Chromosome", "Peak-Start", "Peak-End", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "rank", "Minimum-Distance-to-Gene"))
})


test_that("cleanup is successful for annotate_n", {
  expect_silent(file.remove("peaks.txt"))
  expect_true(file.exists(sprintf("annotated_%s_%s.txt", extension, n)))
  expect_silent(file.remove(sprintf("annotated_%s_%s.txt", extension, n)))
  expect_true(file.exists(sprintf("geneXtender_gtf_%s.bed", extension)))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", extension)))
})

#' Produces line plots.
#'
#' Makes differential line plots showing the differences in the number of genes under peaks at consecutive upstream extension levels.
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param by Interval between consecutive extensions.
#'
#' @return Creates differential line plots.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' linePlot(rat, 1000, 3000, 100)
#'
#'
#' @export
linePlot <- function(organism, start, end, by) {
 if(!file.exists("peaks.txt")){
   message("Please run peaksInput() function first!  See ?peaksInput for more information")
 } else {
	sapply(seq(start, end, by), .geneXtender, organism, FALSE)
	xlabs <- as.character(seq(start, end, by))
	xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
	gxFiles <- sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))


	run <- function(f1, f2, num) {
  		.C("extractnumber", f1, f2, num)[[3]]
	}
	
	num = 0
	numvec <- numeric()
	for (x in gxFiles) {
		numbers <- run(f1 = "peaks.txt", f2 = x, as.integer(num))
		numvec <- append(numvec, numbers)
	}
	
	for (y in numvec) {
		diffs <- sapply(1:length(numvec), function(i) {numvec[i+1] - numvec[i]})
	}
	
	differences <- diffs[!is.na(diffs)]
	par(mar = c(8.1,4.1,2.1,2.1))
	plot(differences, type = "o", col = "blue", xaxt = "n", ylab = "differences", xlab = "")
	axis(1, at = 1:length(differences), labels = xDeltas, las = 3)
	mtext(side = 1, "Genomic region (bp)", line = 6.6)
	}
}

#' Produces line plots of mean (average) peak length within any genomic interval.
#'
#' Makes line plots of mean peak lengths to show the average length of individual peaks within any genomic interval (e.g., 0-500 bp upstream of nearest gene for all genes throughout the genome).
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param by Interval between consecutive extensions.
#'
#' @return Creates mean peak length line plots.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
#' peaksInput(allpeaks)
#' meanPeakLengthPlot(rat, 0, 10000, 500)
#'
#'
#' @export
meanPeakLengthPlot <- function(organism, start, end, by) {
  x <- seq(start, end, by)
  peak_lengths <- sapply(1:(length(x)-1), function(i) {meanPeakLength(organism, x[i], x[i+1])})
  par(mar = c(7.1,4.1,2.1,2.1))
  plot(peak_lengths, type = "o", col = "blue", xaxt = "n", ylab = "mean peak length (bp)", xlab = "")
  xlabs <- as.character(seq(start, end, by))
  xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
  axis(1, at = 1:length(peak_lengths), labels = xDeltas, las = 3)
  mtext(side = 1, "Genomic region (bp)", line = 6)
}

context("meanPeakLength and plot")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

start <- 500
end <- 1500
by <- 100

test_that("correct message is thrown before peaksinput is run", {
  expect_error(meanPeakLength(rat, start, end), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
  expect_error(meanPeakLengthPlot(rat, start, end, by), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("meanPeakLength works properly", {
  expect_equal(meanPeakLength(rat, start, start), 0)
  expect_equal(meanPeakLength(rat, start, end), 3390.304, tolerance = .002, scale = 1)
})

test_that("meanPeakLengthPlot also works properly", {
  expect_silent(meanPeakLengthPlot(rat, start, end, by))
})

test_that("cleanup is successful for meanPeakLength functions", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove("peaks.txt", sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))))
})

#' Produces cumulative line plots.
#'
#' Makes cumulative differential line plots showing the cumulative sums of the number of genes under peaks at consecutive upstream extension levels.
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param by Interval between consecutive extensions.
#'
#' @return Creates cumulative differential line plots.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' cumlinePlot(rat, 1000, 3000, 100)
#'
#'
#' @export
cumlinePlot <- function(organism, start, end, by) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    oopts = options(warn=-1)
    on.exit(options(oopts))
    
    sapply(seq(start, end, by), .geneXtender, organism, FALSE)
    xlabs <- as.character(seq(start, end, by))
    xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
    gxFiles <- sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))
    
    
    run <- function(f1, f2, num) {
      .C("extractnumber", f1, f2, num)[[3]]
    }
    
    num = 0
    numvec <- numeric()
    for (x in gxFiles) {
      numbers <- run(f1 = "peaks.txt", f2 = x, as.integer(num))
      numvec <- append(numvec, numbers)
    }
    
    for (y in numvec) {
      diffs <- sapply(1:length(numvec), function(i) {numvec[i+1] - numvec[i]})
    }
    
    differences <- diffs[!is.na(diffs)]
    cumulative_differences <- cumsum(differences)
    par(mar = c(8.1,4.1,2.1,2.1))
    plot(cumulative_differences, type = "o", col = "red", xaxt = "n", ylab = "cumulative differences", xlab = "")
    axis(1, at = 1:length(cumulative_differences), labels = xDeltas, las = 3)
    mtext(side = 1, "Genomic region (bp)", line = 6.5)
    
  }
}

#' Produces bar charts.
#'
#' Makes bar graphs showing the number of genes under peaks at various upstream extension levels.
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param by Interval between consecutive extensions.
#'
#' @return Creates bar charts.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' barChart(rat, 1000, 3000, 100)
#'
#' @importFrom dplyr filter select arrange
#' @import utils
#' @import graphics
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#'
#' @export
barChart <- function(organism, start, end, by) {
 if(!file.exists("peaks.txt")){
   message("Please run peaksInput() function first!  See ?peaksInput for more information")
 } else {
	oopts = options(warn=-1)
	on.exit(options(oopts))
	
	sapply(seq(start, end, by), .geneXtender, organism, FALSE)
	xlabs <- as.character(seq(start, end, by))
	xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
	gxFiles <- sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))

    
    run <- function(f1, f2, num) {
        .C("extractnumber", f1, f2, num)[[3]]
    }
    
    num = 0
    numvec <- numeric()
	for (x in gxFiles) {
        numbers <- run(f1 = "peaks.txt", f2 = x, as.integer(num))
        numvec <- append(numvec, numbers)
	}
	
	barplot(numvec, names.arg = xlabs)
	
	}
}

context("Bar chart function checker")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

start <- 500
end <- 1500
by <- 100

test_that("correct message is thrown before peaksinput is run", {
  expect_message(barChart(rat, start, end, by), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("barchart works properly", {
  expect_silent(p <- barChart(rat, start, end, by))
})


test_that("cleanup is successful for barChart", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", seq(start, end, by)), "peaks.txt"))
})

#' Plots word frequencies found within gene ontology terms
#'
#' Creates barplots of word frequencies from gene ontology terms derived from either biological process (BP), cellular compartment (CC), or molecular function (MF) of genes-under-peaks that are unique between two different upstream extension levels.
#'
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param GOcategory Either BP, CC, or MF.
#' @param GOspecies Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).  
#' @param word_count Number of top words to display
#'
#' @return A barplot comprised of words sorted by frequency of occurrence from gene ontology terms of either a BP, CC, or MF category.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' library(tm)
#' library(SnowballC)
#' library(wordcloud)
#' library(RColorBrewer)
#' library(org.Rn.eg.db)
#' plotWordFreq(rat, 0, 500, BP, org.Rn.eg.db, 10)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
plotWordFreq <- function(organism, start, end, GOcategory, GOspecies, word_count) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    oopts = options(warn=-1)
    on.exit(options(oopts))
    geneXtender <- function(upstream) {
      messy2 <- dplyr::filter(organism, type == "gene")
      neat <- dplyr::select(messy2, seqid, start, end, strand, gene_id, gene_name)
      pos_exons <- dplyr::filter(neat, strand == "+")
      neg_exons <- dplyr::filter(neat, strand == "-")
      pos_exons$start = pos_exons$start - upstream
      pos_exons$start[pos_exons$start < 0] <- 1
      pos_exons$end = pos_exons$end + 500
      neg_exons$start = neg_exons$start - 500
      neg_exons$start[neg_exons$start < 0] <- 1
      neg_exons$end = neg_exons$end + upstream
      merged_exons <- rbind(pos_exons, neg_exons)
      geneXtender.file <- dplyr::select(merged_exons, seqid, start, end, gene_id, gene_name)
      levels(geneXtender.file$seqid) <- gsub("X", "100", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrX", "100", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("Y", "200", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrY", "200", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("MT", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrMT", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("MtDNA", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrMtDNA", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("M", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrM", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("Mito", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chrMito", "300", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("I", "1", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr1", "1", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("II", "2", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr2", "2", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("III", "3", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr3", "3", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("IV", "4", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr4", "4", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("V", "5", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr5", "5", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("VI", "6", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr6", "6", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("VII", "7", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr7", "7", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("VIII", "8", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr8", "8", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("IX", "9", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr9", "9", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XI", "11", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr11", "11", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XII", "12", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr12", "12", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XIII", "13", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr13", "13", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XIV", "14", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr14", "14", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XV", "15", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr15", "15", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("XVI", "16", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr16", "16", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr17", "17", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr18", "18", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr19", "19", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr20", "20", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr21", "21", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr22", "22", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr23", "23", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr24", "24", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr25", "25", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr26", "26", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr27", "27", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr28", "28", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr29", "29", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr30", "30", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr31", "31", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr32", "32", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr33", "33", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr34", "34", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr35", "35", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr36", "36", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr37", "37", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr38", "38", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr39", "39", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr40", "40", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr41", "41", levels(geneXtender.file$seqid))
      levels(geneXtender.file$seqid) <- gsub("chr42", "42", levels(geneXtender.file$seqid))
      geneXtender.file$seqid = as.numeric(as.character(geneXtender.file$seqid))
      geneXtender.sorted <- dplyr::arrange(geneXtender.file, as.numeric(seqid), start)
      write.table(geneXtender.sorted, quote = FALSE, sep = "\t", row.names = FALSE, col.names = FALSE, sprintf("geneXtender_gtf_%s.bed", upstream))
    }
    
    run2 <- function(f1, f2, peakslist) {
      .C("extractpeaks", f1, f2, peakslist)[[3]]
    }
    
    sapply(c(start, end), geneXtender)
    twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
    linelen <- ""  
    n <- 500000
    peaksArray <- rep(linelen, n)
    peaksArray2 <- rep(linelen, n)
    cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
    cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
    cmd1 <- cmdtmp1[cmdtmp1 != linelen]
    cmd2 <- cmdtmp2[cmdtmp2 != linelen]
    m = regexec("^(?:[^\t]+\t){3}", cmd1)
    first3.cmd1 = unlist(regmatches(cmd1, m))
    m = regexec("^(?:[^\t]+\t){3}", cmd2)
    first3.cmd2 = unlist(regmatches(cmd2, m))
    finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
    DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
    gene_names <- DT[[8]]
    
    if (deparse(substitute(GOcategory)) == 'BP') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'BP']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'CC') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'CC']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'MF') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'MF']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
      
    } else
      message("Not a valid GO category.  Must be either BP, CC, or MF.")
    
  }
  
  GO_terms <- uniq_symbol_GOID_terms$TERM
  GO_terms_corpus <- tm::Corpus(VectorSource(GO_terms))
  GO_terms_corpus <- tm::tm_map(GO_terms_corpus, removeWords, stopwords("english"))
  dtm <- tm::TermDocumentMatrix(GO_terms_corpus)
  doc_term_matrix <- as.matrix(dtm)
  v <- sort(rowSums(doc_term_matrix), decreasing = TRUE)
  d <- data.frame(word = names(v), freq = v)
  
  
  barplot(d[1:as.numeric(word_count),]$freq, 
          las = 2, 
          cex.names = 0.75, 
          names.arg = d[1:as.numeric(word_count),]$word, 
          col = "lightblue", 
          main = "Most frequent words found within GO terms", 
          ylab = "Word frequencies")
  
  
}

#' Produces box-and-whisker plot showing distribution of peak lengths across a peaks input file.
#'
#' Makes boxplots of all peak lengths (within a peaks input file) to show how lengths of individual peaks are distributed across the entire peak set.
#'
#' @param filename Name of peaks input file.
#'
#' @return Returns a box-and-whisker plot of peak length distribution across a peaks file.
#'
#' @examples
#' myfile <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' allPeakLengths(myfile)
#'
#' @import data.table
#' 
#' @export
allPeakLengths <- function(filename) {
  oopts = options(warn=-1)
  on.exit(options(oopts))
  file.input <- data.table::fread(filename)
  file.input$diff <- file.input$end - file.input$start
  boxplot(file.input$diff, horizontal = TRUE, xlab = "peak length (bp)")
}

context("All peaks length tester")

test_that("all peaks length graphs produces properly", {
  peaksGraph <- allPeakLengths(fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))
  
  expect_equal(peaksGraph$n, 25089)
})

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

#' Produces box-and-whisker plot of peak lengths within any genomic interval.
#'
#' Makes boxplots of peak lengths to show how lengths of individual peaks are distributed within any genomic interval (e.g., 0-500 bp upstream of nearest gene for all genes throughout the genome).
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#'
#' @return Creates boxplots showing how lengths of peaks are distributed within any given genomic interval.  Also, creates character vector composed of individual peak lengths.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
#' peaksInput(allpeaks)
#' peakLengthBoxplot(rat, 0, 500)
#'
#'
#' @export
peakLengthBoxplot <- function(organism, start, end) {
  a <- distinct(organism, start, end)
  b <- as.numeric(a$`Peak-End`) - as.numeric(a$`Peak-Start`)
  boxplot(b, ylab = "peak length (bp)")
  b
}

context("Distinct tests and peakLengthBoxplot")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

start <- 100
end <- 5000

test_that("correct message is thrown before peaksinput is run", {
  expect_error(distinct(rat, start, end), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
  expect_error(peakLegthBoxPlot(rat, start, end), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("distinct works properly", {
  expect_silent(distinct(rat, start, end))
  p <- distinct(rat, start, end)
  expect_equal(dim(p), c(1034, 9))
  expect_length(unique(p$Distance), 1)
  expect_silent(peakLengthBoxplot(rat, start, end))
})

test_that("cleanup is successful for cumlinePlot", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", c(start, end)), "peaks.txt"))
})

#' Makes gene-GO networks
#'
#' Creates dynamic and interactive networks of genes linked to their respective gene ontology terms for each category (biological process (BP), cellular compartment (CC), molecular function (MF)) of genes-under-peaks that are unique between two different upstream extension levels.
#'
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param GOcategory Either BP, CC, or MF.
#' @param GOspecies Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).  
#'
#' @return An interactive network of gene names linked to their respective gene ontology terms for either a BP, CC, or MF category.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' library(networkD3)
#' library(dplyr)
#' library(org.Rn.eg.db)
#' makeNetwork(rat, 0, 500, BP, org.Rn.eg.db)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#' 
#' 
#' @importFrom dplyr left_join select %>% rename id
#' @importFrom networkD3 forceNetwork JS
#'
#' @export
makeNetwork <- function(organism, start, end, GOcategory, GOspecies) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    
    run2 <- function(f1, f2, peakslist) {
      .C("extractpeaks", f1, f2, peakslist)[[3]]
    }
    
    sapply(c(start, end), .geneXtender, organism, FALSE)
    twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
    linelen <- ""  
    n <- 500000
    peaksArray <- rep(linelen, n)
    peaksArray2 <- rep(linelen, n)
    cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
    cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
    cmd1 <- cmdtmp1[cmdtmp1 != linelen]
    cmd2 <- cmdtmp2[cmdtmp2 != linelen]
    m = regexec("^(?:[^\t]+\t){3}", cmd1)
    first3.cmd1 = unlist(regmatches(cmd1, m))
    m = regexec("^(?:[^\t]+\t){3}", cmd2)
    first3.cmd2 = unlist(regmatches(cmd2, m))
    finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
    DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
    gene_names <- DT[[8]]
    
    if (deparse(substitute(GOcategory)) == 'BP') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'BP']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'CC') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'CC']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'MF') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'MF']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      uniq_symbol_GOID_terms <- unique(symbol_GOID_terms)
      
    } else {
      stop("Not a valid GO category.  Must be either BP, CC, or MF.")
    }
    
  
  
  src <- as.character(uniq_symbol_GOID_terms$`gene$SYMBOL`)
  target <- as.character(uniq_symbol_GOID_terms$TERM)
  networkData <- data.frame(src, target, stringsAsFactors = FALSE)
  nodes <- data.frame(name = unique(c(src, target)), stringsAsFactors = FALSE)
  nodes$id <- 0:(nrow(nodes) - 1)
  
  edges <- networkData %>%
    left_join(nodes, by = c("src" = "name")) %>%
    dplyr::select(-src) %>%
    rename(source = id) %>%
    left_join(nodes, by = c("target" = "name")) %>%
    dplyr::select(-target) %>%
    rename(target = id)
  
  edges$width <- 1
  nodes$group <- ifelse(nodes$name %in% src, "lions", "tigers")
  
  ColourScale <- 'd3.scaleOrdinal()
            .domain(["lions", "tigers"])
           .range(["#FF6900", "#694489"]);'
  
  forceNetwork(Links = edges, Nodes = nodes, 
               Source = "source",
               Target = "target",
               NodeID ="name",
               Group = "group",
               Value = "width",
               opacity = 0.9,
               zoom = TRUE,
               charge = -10,
               colourScale = JS(ColourScale))
  }
}

#' Finds unique genes under peaks.
#'
#' Determines what genes directly under peaks are actually unique between two different upstream extension levels.
#' 
#' V1-V3 denote the chromosome/start/end positions of the peaks, V4-V6 denote the respective values of the genes, V7 is the gene ID (e.g., Ensembl ID), V8 is the gene name, and V9 is the distance of peak to nearest gene.
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#'
#' @return A data.table of unique genes located under peaks between two upstream extension levels.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' distinct(rat, 2000, 3000)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#' 
#' @import data.table
#'
#' @export
distinct <- function(organism, start, end) {
 if(!file.exists("peaks.txt")){
   stop("Please run peaksInput() function first!  See ?peaksInput for more information")
 } else {
        oopts = options(warn=-1)
        on.exit(options(oopts))
        run2 <- function(f1, f2, peakslist) {
            .C("extractpeaks", f1, f2, peakslist)[[3]]
        }
        
    		sapply(c(start, end), .geneXtender, organism, FALSE)
    		twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
        linelen <- ""  
        n <- 500000
        peaksArray <- rep(linelen, n)
        peaksArray2 <- rep(linelen, n)
        cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
        cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
        cmd1 <- cmdtmp1[cmdtmp1 != linelen]
        cmd2 <- cmdtmp2[cmdtmp2 != linelen]
        m = regexec("^(?:[^\t]+\t){3}", cmd1)
        first3.cmd1 = unlist(regmatches(cmd1, m))
        m = regexec("^(?:[^\t]+\t){3}", cmd2)
        first3.cmd2 = unlist(regmatches(cmd2, m))
        finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
        col.names <- c("Chromosome", "Peak-Start", "Peak-End", "Gene-Chr", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Distance")
        DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
        names(DT) <- col.names
        return(DT)
	}
}

#' Sample peaks list to be used as input to geneXtendeR
#'
#' A dataset containing the chromosome number, start and stop positions
#' of ChIP-seq peaks along the Rattus norvegicus genome (rn6 assembly).
#' A dataset like this may be used as input to the peaksInput() command, 
#' which will sort the dataset by chromosome number and start position.
#'
#' @docType data
#'
#' @usage data(samplepeaksinput)
#' 
#' @return Demonstrates a sample peaks file used as input.
#'
#' @examples 
#' head(samplepeaksinput)
#' tail(samplepeaksinput)
#'
#' @format A data frame with 25089 rows and 3 variables:
#' \describe{
#' \item{chr}{Chromosome number}
#' \item{start}{Peak start position [in units of base pairs]}
#' \item{end}{Peak end position [in units of base pairs]}
#' }
#'
#' @keywords datasets
"samplepeaksinput"

#' Calculates mean (average) peak length for any genomic region.
#'
#' Determines the average peak length of all peaks found within some genomic interval (e.g., 0-500 bp upstream of nearest gene for all genes throughout the genome).
#' 
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#'
#' @return A vector composed of a single number representing the average peak length found within a genomic interval.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' sigpeaks <- system.file("extdata", "significantpeaksfile.txt", package="geneXtendeR")
#' peaksInput(sigpeaks)
#' meanPeakLength(rat, 0, 500)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
meanPeakLength <- function(organism, start, end) {
  if(!file.exists("peaks.txt")){
    stop("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    
    run2 <- function(f1, f2, peakslist) {
      .C("extractpeaks", f1, f2, peakslist)[[3]]
    }
    
    sapply(c(start, end), .geneXtender, rat, FALSE)
    twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
    linelen <- ""  
    n <- 500000
    peaksArray <- rep(linelen, n)
    peaksArray2 <- rep(linelen, n)
    cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
    cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
    cmd1 <- cmdtmp1[cmdtmp1 != linelen]
    cmd2 <- cmdtmp2[cmdtmp2 != linelen]
    m = regexec("^(?:[^\t]+\t){3}", cmd1)
    first3.cmd1 = unlist(regmatches(cmd1, m))
    m = regexec("^(?:[^\t]+\t){3}", cmd2)
    first3.cmd2 = unlist(regmatches(cmd2, m))
    finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
    DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
    if (nrow(DT) == 0) return(0)
    return(mean(as.numeric(DT$V3) - as.numeric(DT$V2)))
  }      
}

#' Finds differential gene ontologies
#'
#' Determines gene ontology terms for each category (biological process (BP), cellular compartment (CC), molecular function (MF)) of genes-under-peaks that are unique between two different upstream extension levels.
#'
#'
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param GOcategory Either BP, CC, or MF.
#' @param GOspecies Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).  
#'
#' @return A data frame of gene symbol, gene ontology ID, and gene ontology term for either a BP, CC, or MF category.  This data frame displays the annotations of all unique genes (i.e., genes that are located under peaks between two upstream extension levels) with their respective gene ontology information.
#'
#' @importFrom GO.db GO.db
#' 
#' @examples
#' library(rtracklayer)
#' library(org.Rn.eg.db)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' diffGO(rat, 0, 500, BP, org.Rn.eg.db)
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
diffGO <- function(organism, start, end, GOcategory, GOspecies) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {

    run2 <- function(f1, f2, peakslist) {
      .C("extractpeaks", f1, f2, peakslist)[[3]]
    }

    sapply(c(start, end), .geneXtender, rat, FALSE)
    twogxFiles <- sprintf("geneXtender_gtf_%s.bed", c(start, end))
    linelen <- ""  
    n <- 500000
    peaksArray <- rep(linelen, n)
    peaksArray2 <- rep(linelen, n)
    cmdtmp1 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[1]], as.character(peaksArray))
    cmdtmp2 <- run2(f1 = "peaks.txt", f2 = twogxFiles[[2]], as.character(peaksArray2))
    cmd1 <- cmdtmp1[cmdtmp1 != linelen]
    cmd2 <- cmdtmp2[cmdtmp2 != linelen]
    m = regexec("^(?:[^\t]+\t){3}", cmd1)
    first3.cmd1 = unlist(regmatches(cmd1, m))
    m = regexec("^(?:[^\t]+\t){3}", cmd2)
    first3.cmd2 = unlist(regmatches(cmd2, m))
    finalList = cmd2[!(first3.cmd2 %in% first3.cmd1)]
    DT <- data.table::as.data.table(do.call("rbind", strsplit(finalList, split = "\t")))
    gene_names <- DT[[8]]

    if (deparse(substitute(GOcategory)) == 'BP') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'BP']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'CC') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'CC']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      unique(symbol_GOID_terms)
    } else if (deparse(substitute(GOcategory)) == 'MF') {
      gene_names_annotated <- AnnotationDbi::select(GOspecies, gene_names, "GO", "SYMBOL")
      gene_names_annotated_DT <- as.data.table(gene_names_annotated)
      Gene <- gene_names_annotated_DT[gene_names_annotated_DT$ONTOLOGY == 'MF']
      gene <- as.data.frame(Gene)
      terms <- AnnotationDbi::select(GO.db, as.character(gene[,2]), "TERM", "GOID")
      symbol_GOID_terms <- cbind(gene$SYMBOL, terms)
      unique(symbol_GOID_terms)
    } else
      message("Not a valid GO category.  Must be either BP, CC, or MF.")

  }

}

context("diffGo tests")
library(org.Rn.eg.db)

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

start <- 500
end <- 1500
GOspecies <- org.Rn.eg.db

test_that("correct message is thrown before peaksinput is run", {
  expect_message(diffGO(rat, start, end, BP, GOspecies), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("error is thrown when not selecting correct category", {
  expect_message(diffGO(rat, start, end, AP, GOspecies), "Not a valid GO category.  Must be either BP, CC, or MF.")
})

test_that("function runs properly for each category", {
  expect_message(p <- diffGO(rat, start, end, BP, GOspecies))
  expect_message(p <- diffGO(rat, start, end, CC, GOspecies))
  expect_message(p <- diffGO(rat, start, end, MF, GOspecies))
})

#' This function changes every so often. Output is difficult to test
# test_that("function output is correct for BP", {
#   p <- diffGO(rat, start, end, BP, GOspecies)
#   expect_equal(dim(p), c(739, 3)) # Changes often, test needs to be revised
#   expect_length(unique(p$`gene$SYMBOL`), 77)
# })


test_that("cleanup is successful for diffGO", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", c(start, end)), "peaks.txt"))
})

#' Annotate peak file based on gene.
#'
#' Annotate a user's peaks file (which has been preprocessed with the peaksInput() command) with gene information based on optimally chosen geneXtendeR upstream extension file and compresses the annotations based on genes.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
#'
#' @param organism Object name assigned from readGFF() command.
#' @param extension Desired upstream extension.
#' 
#' @return The gene coordinates are extended by `extension` at the 5-prime end, and by 500 bp at the 3-prime end.  The peaks file is then overlayed on these new gene coordinates, producing a file of peaks annotated with gene ID, gene name, gene location, mean and standard deviation of peaks-to-genes, number of peaks-to-genes, and peak-to-gene genomic distance (in bp).  Distance is calculated between 5-prime end of gene and 3-prime end of peak.
#' @return A data.table formatted version of the gene-annotated file for checking or further calculations.
#' 
#' @return (From annotate.r) The gene coordinates are extended by `extension` at the 5-prime end, and by 500 bp at the 3-prime end.  The peaks file is then overlayed on these new gene coordinates, producing a file of peaks annotated with gene ID, gene name, and gene-to-peak genomic distance (in bp).  Distance is calculated between 5-prime end of gene and 3-prime end of peak.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' gene_annotate(rat, 3400)
#' 
#' @useDynLib geneXtendeR, .registration = TRUE
#' @import data.table
#' @importFrom dplyr desc
#'
#' @export
gene_annotate <- function(organism, extension) {
  PeaktoGeneAnno <- annotate(organism, extension)
  
  GtPA <- PeaktoGeneAnno[,
                         .('Peaks-on-Gene-Body' = sum(`Distance-of-Gene-to-Nearest-Peak` == 0),
                           mean = mean(`Distance-of-Gene-to-Nearest-Peak`),
                           sd = sd(`Distance-of-Gene-to-Nearest-Peak`),
                           .N),
                         by=.(`Chromosome`, `Gene-Start`, `Gene-End`, `Gene-ID`, `Gene-Name`)]
  data.table::setnames(GtPA, c("N", "mean"), c("Number-of-Peaks-Associated-with-Gene", "Mean-Distance-of-Gene-to-Nearest-Peaks"))
  
  GtPA <- dplyr::arrange(GtPA,desc(`Peaks-on-Gene-Body`), desc(`Number-of-Peaks-Associated-with-Gene`))
  
  data.table::fwrite(
    GtPA,
    file = sprintf("gene_annotated_%s.txt", extension),
    sep = "\t",
    row.names = FALSE,
    col.names = TRUE,
    quote = FALSE
  )
  return(GtPA[])
}

context("gene annotation testing")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}
extension <- 1234

test_that("correct message is thrown before peaksinput is run", {
  expect_error(gene_annotate(rat, extension), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("gene_annotate works properly", {
  expect_silent(gene_annotate(rat, extension))
  p <- gene_annotate(rat, extension)
  expect_equal(dim(p), c(11815, 9))
  expect_equal(sum(p$`Number-of-Peaks-Associated-with-Gene`), dim(data.table::fread("peaks.txt"))[1])
})

test_that("cleanup is successful for gene_annotate", {
  expect_true(file.exists("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", extension), "peaks.txt"))
})

#' Transform peaks into merged peaks.
#'
#' Takes your tab-delimited 3-column (chromosome number, peak start, and peak end) input file (see ?samplepeaksinput) consisting of peaks called from a peak caller (e.g., MACS2 or SICER) and transforms this file into a file of merged peaks.  This file (called "peaks.txt") is a preprocessed file of the original input transformed into merged peaks, and it is deposited in the user's working directory and used for the remainder of the analysis.  In this "peaks.txt" file, peaks are sorted by chromosome number and start position, where the X chromosome is designated by the integer 100, the Y chromosome by the integer 200, and the mitochondrial chromosome by the integer 300.
#'
#' @param filename Name of file containing peaks that have been generated from a peak caller (e.g., MACS2, SICER).  See ?samplepeaksinput for an example of such an input file.
#' @param mergeby Integer indicating how close two adjacent sorted peaks need to be in order to be merged into one peak.
#'
#' @return Returns a formatted file (called "peaks.txt"), deposited in the user's working directory, which has been preprocessed to transform individual peaks into merged peaks in preparation for usage with barChart(), linePlot(), distinct(), and other downstream commands.
#'
#' @examples
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksMerge(fpath, 500)
#'
#' @import data.table
#' @import rtracklayer
#' 
#' @export
peaksMerge <- function(filename, mergeby) {
  oopts = options(warn=-1)
  on.exit(options(oopts))
  file.input <- fread(filename)
  file.input[chr == "chr1", chr := 1]
  file.input[chr == "chr2", chr := 2]
  file.input[chr == "chr3", chr := 3]
  file.input[chr == "chr4", chr := 4]
  file.input[chr == "chr5", chr := 5]
  file.input[chr == "chr6", chr := 6]
  file.input[chr == "chr7", chr := 7]
  file.input[chr == "chr8", chr := 8]
  file.input[chr == "chr9", chr := 9]
  file.input[chr == "chr10", chr := 10]
  file.input[chr == "chr11", chr := 11]
  file.input[chr == "chr12", chr := 12]
  file.input[chr == "chr13", chr := 13]
  file.input[chr == "chr14", chr := 14]
  file.input[chr == "chr15", chr := 15]
  file.input[chr == "chr16", chr := 16]
  file.input[chr == "chr17", chr := 17]
  file.input[chr == "chr18", chr := 18]
  file.input[chr == "chr19", chr := 19]
  file.input[chr == "chr20", chr := 20]
  file.input[chr == "chr21", chr := 21]
  file.input[chr == "chr22", chr := 22]
  file.input[chr == "chr23", chr := 23]
  file.input[chr == "chr24", chr := 24]
  file.input[chr == "chr25", chr := 25]
  file.input[chr == "chr26", chr := 26]
  file.input[chr == "chr27", chr := 27]
  file.input[chr == "chr28", chr := 28]
  file.input[chr == "chr29", chr := 29]
  file.input[chr == "chr30", chr := 30]
  file.input[chr == "chr31", chr := 31]
  file.input[chr == "chr32", chr := 32]
  file.input[chr == "chr33", chr := 33]
  file.input[chr == "chr34", chr := 34]
  file.input[chr == "chr35", chr := 35]
  file.input[chr == "chr36", chr := 36]
  file.input[chr == "chr37", chr := 37]
  file.input[chr == "chr38", chr := 38]
  file.input[chr == "chr39", chr := 39]
  file.input[chr == "chr40", chr := 40]
  file.input[chr == "chr41", chr := 41]
  file.input[chr == "chr42", chr := 42]
  file.input[chr == "chr43", chr := 43]
  file.input[chr == "X", chr := 100]
  file.input[chr == "chrX", chr := 100]
  file.input[chr == "Y", chr := 200]
  file.input[chr == "chrY", chr := 100]
  file.input[chr == "MT", chr := 300]
  file.input[chr == "chrMT", chr := 300]
  file.input[chr == "MtDNA", chr := 300]
  file.input[chr == "chrMtDNA", chr := 300]
  file.input[chr == "M", chr := 300]
  file.input[chr == "chrM", chr := 300]
  file.input[chr == "Mito", chr := 300]
  file.input[chr == "chrMito", chr := 300]
  file.sorted <- dplyr::arrange(file.input, as.numeric(chr), start)
  setDT(file.sorted)
  num = mergeby
  file.sorted[, g := cumsum(start - shift(end, fill = first(start)) >= num), by = chr]
  DT <- file.sorted[, .(start = first(start), end = last(end)), by = .(chr, g = data.table::rleid(chr, g))]
  DT[, g := NULL]
  write.table(DT, file = "peaks.txt", quote = FALSE, sep = "\t", row.names = FALSE, col.names = FALSE)
}

#' Looks up specific gene and closest peaks
#'
#' Looks up closest peak to a specified gene on the peaks file (which has been preprocessed with the peaksInput() command) based on the latest .bed file accessed or for a specified extension.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param gene_name Gene names or gene ids specified by user in a string form. 
#' @param n Number of closest peaks located to `gene_name` on any given chromosome to be found. Default = 2
#' @param extension Desired upstream extension. If left unspecified, the latest geneXtender bed file will be chosen. If no extension is specified and no bed file can be found, a default extension of 500 is selected.
#' @param cutoff Optional arg to specify max bp distance to search around `gene_name`. Default = Inf
#'
#' @return A data.table with all peaks located within `n` peaks and `cutoff` bp distance away on every chromosome that contains `gene_name`.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' closest <- gene_lookup(rat, c("Vom2r3", "Vom2r5"), n = 7, extension = 1000)
#' closest
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
gene_lookup <- function(organism, gene_name, n=2, extension = NA, cutoff = Inf) {
  if(!file.exists("peaks.txt")){
    message("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else if (cutoff < 0 | n < 1) {
    message("Please select a cutoff >= 0 or a value of n >= 1")
  } else {
    genes <- NULL
    
    if (!is.na(extension)) {
      file <- sprintf("geneXtender_gtf_%i.bed", extension)
      # if (file.exists(file)) { #Only useful assuming that the organisms are the same. unable to check so leave commented
      #   genes <- data.table::fread(file)
      # }
      # else {
      genes <- .geneXtender(extension, organism, TRUE)
      # }
    } else {
      files <- grep("geneXtender_gtf_*", list.files(), value=TRUE)
      if (length(files) == 0) { #If no bed file exists, generate one with default upstream of 500
        genes <- .geneXtender(500, organism, TRUE)
        files <- grep("geneXtender_gtf_*", list.files(), value=TRUE)
        files_check <- c("geneXtender_gtf_500.bed")
      }
      
      file_info <- file.info(files)
      file_info <- file_info[order(-as.numeric(file_info$atime)),]
      recent_extension <- row.names(file_info)[1]
      genes <- data.table::fread(recent_extension)
    }
    colnames(genes) <- c("seqid", "start", "end", "gene_id", "gene_name_id")
    
    genez <- genes[tolower(gene_name_id) %in% tolower(gene_name) | tolower(gene_id) %in% tolower(gene_name),]
    
    peaks <- data.table::fread("peaks.txt")
    colnames(peaks) <- c("Chromosome", "Peak-Start", "Peak-End")
    
    internal_find <- function(dtc) {
      peak <- subset(peaks, Chromosome == dtc$seqid)
      
      peak$es <- dtc$start - peak$`Peak-End`
      peak$se <- dtc$end - peak$`Peak-Start`
      
      peak$distance <- ifelse(data.table::between(0, pmin(peak$es, peak$se), pmax(peak$es,peak$se)), 0, pmin(abs(peak$es), abs(peak$se)))
      
      peak <- data.table::setorderv(peak, "distance")
      
      zeroes <- peak[, distance == 0]
      
      vals <- peak[order(distance)]
      vals <- na.omit(vals[1:n,])
      
      
      #ERROR CHECKING
      if(nrow(peak) < n) {
        warning(sprintf("Warning! There were more peaks requested on Chromosome on %i than exist on the peaks.txt file.
                        Only %i peaks could be found on Chromosome %i and were returned.", dtc$seqid, nrow(peak), dtc$seqid))
      }
      return(cbind(vals, dtc))
    }
    
    genez[, ..I := .I]
    report <- genez[, internal_find(.SD), by = ..I]
    report <- report[distance <= cutoff]
    
    report[, c('..I', 'es', 'se', 'seqid', 'gene_id') := NULL]
    data.table::setnames(report, c("Chromosome", "Peak-Start", "Peak-End", "Distance-to-Gene", "Gene-Start", "Gene-End", "Gene"))
    
    
    return(report[])
  }
}

#' Preprocesses a peaks input file.
#'
#' Takes your tab-delimited 3-column (chromosome number, peak start, and peak end) input file (see ?samplepeaksinput) consisting of peaks called from a peak caller (e.g., MACS2 or SICER) and sorts the file by chromosome and start position, thereby creating a preprocessed file for downstream geneXtendeR analysis.  This file (called "peaks.txt") is a preprocessed file of the original input and is deposited in the user's working directory and used for the remainder of the analysis.  In this "peaks.txt" file, peaks are sorted by chromosome number and start position, where the X chromosome is designated by the integer 100, the Y chromosome by the integer 200, and the mitochondrial chromosome by the integer 300.
#'
#' @param filename Name of file containing peaks that have been generated from a peak caller (e.g., MACS2, SICER).  See ?samplepeaksinput for an example of such an input file.
#'
#' @return Returns a formatted file (called "peaks.txt") that has been preprocessed in preparation for usage with barChart(), linePlot(), distinct(), and other downstream commands and deposited in the user's working directory.
#'
#' @examples
#' ?samplepeaksinput  #Documentation of some exemplary sample input
#' data(samplepeaksinput)
#' head(samplepeaksinput)
#' tail(samplepeaksinput)
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#'
#' @importFrom data.table fread
#' @import rtracklayer
#' 
#' @export
peaksInput <- function(filename) {
  file.input <- fread(filename)
  if (ncol(file.input) != 3) {
    stop("Must be a 3-column tab-demimited file. (see ?samplepeaksinput)")
  }
	file.input[chr == "chr1", chr := '1']
	file.input[chr == "chr2", chr := '2']
	file.input[chr == "chr3", chr := '3']
	file.input[chr == "chr4", chr := '4']
	file.input[chr == "chr5", chr := '5']
	file.input[chr == "chr6", chr := '6']
	file.input[chr == "chr7", chr := '7']
	file.input[chr == "chr8", chr := '8']
	file.input[chr == "chr9", chr := '9']
	file.input[chr == "chr10", chr := '10']
	file.input[chr == "chr11", chr := '11']
	file.input[chr == "chr12", chr := '12']
	file.input[chr == "chr13", chr := '13']
	file.input[chr == "chr14", chr := '14']
	file.input[chr == "chr15", chr := '15']
	file.input[chr == "chr16", chr := '16']
	file.input[chr == "chr17", chr := '17']
	file.input[chr == "chr18", chr := '18']
	file.input[chr == "chr19", chr := '19']
	file.input[chr == "chr20", chr := '20']
	file.input[chr == "chr21", chr := '21']
	file.input[chr == "chr22", chr := '22']
	file.input[chr == "chr23", chr := '23']
	file.input[chr == "chr24", chr := '24']
	file.input[chr == "chr25", chr := '25']
	file.input[chr == "chr26", chr := '26']
	file.input[chr == "chr27", chr := '27']
	file.input[chr == "chr28", chr := '28']
	file.input[chr == "chr29", chr := '29']
	file.input[chr == "chr30", chr := '30']
	file.input[chr == "chr31", chr := '31']
	file.input[chr == "chr32", chr := '32']
	file.input[chr == "chr33", chr := '33']
	file.input[chr == "chr34", chr := '34']
	file.input[chr == "chr35", chr := '35']
	file.input[chr == "chr36", chr := '36']
	file.input[chr == "chr37", chr := '37']
	file.input[chr == "chr38", chr := '38']
	file.input[chr == "chr39", chr := '39']
	file.input[chr == "chr40", chr := '40']
	file.input[chr == "chr41", chr := '41']
	file.input[chr == "chr42", chr := '42']
	file.input[chr == "chr43", chr := '43']
  file.input[chr == "X", chr := '100']
  file.input[chr == "chrX", chr := '100']
  file.input[chr == "Y", chr := '200']
  file.input[chr == "chrY", chr := '100']
  file.input[chr == "MT", chr := '300']
  file.input[chr == "chrMT", chr := '300']
  file.input[chr == "MtDNA", chr := '300']
  file.input[chr == "chrMtDNA", chr := '300']
  file.input[chr == "M", chr := '300']
  file.input[chr == "chrM", chr := '300']
  file.input[chr == "Mito", chr := '300']
  file.input[chr == "chrMito", chr := '300']
  file.sorted <- dplyr::arrange(file.input, as.numeric(chr), as.numeric(start))
  write.table(na.omit(file.sorted), file = "peaks.txt", quote = FALSE, sep = "\t", row.names = FALSE, col.names = FALSE)
}

context("peaks-input checker")

test_that("peaksInput inputs and null", {
  fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
  peaksInput(fpath)
  
  expect_error(peaksInput(''))
  expect_true(file.exists("peaks.txt"))
  file.remove("peaks.txt")
})

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}

context("annotate()")

if (file.exists("peaks.txt")) {
  file.remove("peaks.txt")
}
extension <- 1234

test_that("peaks file needs to be created first", {
  expect_error(annotate(rat, extension), message = "Please run peaksInput() function first!  See ?peaksInput for more information")
})

peaksInput(system.file("extdata", "somepeaksfile.txt", package="geneXtendeR"))

test_that("annotated file exists and is correct", {
  annotated <- annotate(rat, extension)
  
  expect_true(file.exists(sprintf("peaks_annotated_%s.txt", extension)))
  expect_equal(names(annotated), c("Chromosome", "Peak-Start", "Peak-End", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Distance-of-Gene-to-Nearest-Peak"))
  expect_equal(dim(annotated)[1], dim(samplepeaksinput)[1])
})

test_that("cleanup for this method works", {
  expect_silent(file.remove("peaks.txt"))
  expect_silent(file.remove(sprintf("peaks_annotated_%s.txt", extension)))
  expect_true(file.exists(sprintf("geneXtender_gtf_%s.bed", extension)))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", extension)))
})

#' Graphs hotspots of statistically significant peak activity.
#'
#' Makes line plots showing the ratio of statistically significant peaks to the total number of peaks at each genomic interval (e.g., 0-500 bp upstream of every gene in the genome, 500-1000 bp upstream of every gene in the genome, etc.).
#'
#'
#' @param totalpeaksfile Filename in user's working directory (or full path to filename) containing all peaks.
#' @param significantpeaksfile Filename in user's working directory (or full path to filename) containing only significant peaks.
#' @param organism Object name assigned from readGFF() command.
#' @param start Lower bound of upstream extension.
#' @param end Upper bound of upstream extension.
#' @param by Interval between consecutive extensions.
#'
#' @return Line plot showing the ratio of significant to total peaks at each interval across the genome.
#' 
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
#' sigpeaks <- system.file("extdata", "significantpeaksfile.txt", package="geneXtendeR")
#' hotspotPlot(allpeaks, sigpeaks, rat, 0, 10000, 500)
#'
#'
#' @export
hotspotPlot <- function(totalpeaksfile, significantpeaksfile, organism, start, end, by) {
    peaksInput(totalpeaksfile)
  
    sapply(seq(start, end, by), .geneXtender, organism, FALSE)
    xlabs <- as.character(seq(start, end, by))
    xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
    gxFiles <- sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))
    
    
    run <- function(f1, f2, num) {
      .C("extractnumber", f1, f2, num)[[3]]
    }
    
    num = 0
    numvec <- numeric()
    for (x in gxFiles) {
      numbers <- run(f1 = "peaks.txt", f2 = x, as.integer(num))
      numvec <- append(numvec, numbers)
    }
    
    for (y in numvec) {
      diffs <- sapply(1:length(numvec), function(i) {numvec[i+1] - numvec[i]})
    }
    
    totaldifferences <- diffs[!is.na(diffs)]
    
    #----Now let's repeat for significant peaks----#
    
    peaksInput(significantpeaksfile)
    
    sapply(seq(start, end, by), .geneXtender, organism, FALSE)
    xlabs <- as.character(seq(start, end, by))
    xDeltas <- vapply(seq_along(xlabs)[-1], function(i) paste(xlabs[(i-1):i], collapse = "-"), "")
    gxFiles <- sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))
    
    
    run <- function(f1, f2, num) {
      .C("extractnumber", f1, f2, num)[[3]]
    }
    
    num = 0
    numvec <- numeric()
    for (x in gxFiles) {
      numbers <- run(f1 = "peaks.txt", f2 = x, as.integer(num))
      numvec <- append(numvec, numbers)
    }
    
    for (y in numvec) {
      diffs <- sapply(1:length(numvec), function(i) {numvec[i+1] - numvec[i]})
    }
    
    significantdifferences <- diffs[!is.na(diffs)]
    
    
    psiMetric <- significantdifferences/totaldifferences
    par(mar = c(7.1,4.1,2.1,2.1))
    plot(psiMetric, type = "o", col = "blue", xaxt = "n", ylab = expression(paste("Significant Peaks /Total Peaks ( ", psi, " )")), xlab = "")
    axis(1, at = 1:length(psiMetric), labels = xDeltas, las = 3)
    mtext(side = 1, "Genomic region (bp)", line = 6)
    
  
}

context("Hotspotplot")

allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
sigpeaks <- system.file("extdata", "significantpeaksfile.txt", package="geneXtendeR")
start <- 0
end <- 5000
by <- 200

test_that("hotspotPlot works", {
  expect_silent(hotspotPlot(allpeaks, sigpeaks, rat, start, end, by))
})

test_that("cleanup is successful for hotspotPlot", {
  expect_silent(file.remove("peaks.txt"))
  expect_silent(file.remove(sprintf("geneXtender_gtf_%s.bed", seq(start, end, by))))
})

#' Annotate peaks file.
#'
#' Annotate a user's peaks file (which has been preprocessed with the peaksInput() command) with gene information based on optimally chosen geneXtendeR upstream extension file.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
#' 
#' @param organism Object name assigned from readGFF() command.
#' @param extension Desired upstream extension.
#'
#' @return The gene coordinates are extended by `extension` at the 5-prime end, and by 500 bp at the 3-prime end.  The peaks file is then overlayed on these new gene coordinates, producing a file of peaks annotated with gene ID, gene name, and gene-to-peak genomic distance (in bp).  Distance is calculated between 5-prime end of gene and 3-prime end of peak.
#' @return A data.table formatted version of the annotated file for checking or further calculations.
#'
#' @examples
#' library(rtracklayer)
#' rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
#' fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
#' peaksInput(fpath)
#' annotate(rat, 2500)
#'
#' @import data.table
#'
#' @useDynLib geneXtendeR, .registration = TRUE
#'
#' @export
annotate <- function(organism, extension) {
  if(!file.exists("peaks.txt")){
    stop("Please run peaksInput() function first!  See ?peaksInput for more information")
  } else {
    oopts = options(warn=-1)
    on.exit(options(oopts))
    
    run3 <- function(f1, f2, peakslist) {
      .C("annotate", f1, f2, peakslist)[[3]]
    }
    
    linelen <- "                                                                                                                                  "
    n <- 500000
    peaksArray<-rep(linelen,n)
    sapply(extension, .geneXtender, organism, FALSE)
    onegxFile <- sprintf("geneXtender_gtf_%s.bed", extension)
    onecmd2 <- run3(f1 = "peaks.txt", f2 = onegxFile, peakslist = peaksArray) 
    onecmd3 <- onecmd2[onecmd2 != linelen]
    
    write.table(
      onecmd3,
      file = sprintf("peaks_annotated_%s.txt", extension),
      sep = "\t",
      row.names = FALSE,
      col.names = paste("Chromosome\t", "Peak-Start\t", "Peak-End\t", "Chromosome\t", "Gene-Start\t", "Gene-End\t", "Gene-ID\t", "Gene-Name\t", "Distance-of-Gene-to-Nearest-Peak"),
      quote = FALSE
    )
    
    rdt <- data.table::transpose(data.table::as.data.table(strsplit(onecmd3, "\t"))) #Formatting
    colnames(rdt) <- c("Chromosome", "Peak-Start", "Peak-End", "rm", "Gene-Start", "Gene-End", "Gene-ID", "Gene-Name", "Distance-of-Gene-to-Nearest-Peak")
    rdt <- rdt[,rm:= NULL]
    for (j in c("Chromosome", "Peak-Start", "Peak-End", "Gene-Start", "Gene-End", "Distance-of-Gene-to-Nearest-Peak")) data.table::set(rdt, j=j, value = as.numeric(rdt[[j]]))
    return(rdt[])
 }      
}

#' Gene transfer format (GTF) file for rat (Rattus_norvegicus.Rnor_6.0.84)
#'
#' A dataset downloaded from Ensembl that contains the entries of a GTF file for Rattus norvegicus.
#'
#' @docType data
#'
#' @usage data(rat)
#' 
#' @return Demonstrates a rat GTF file downloaded from: ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz.
#'
#' @examples 
#' head(rat)
#' tail(rat)
#'
#' @format A data frame with 748514 rows and 28 variables corresponding to the entries of a GTF file.  Column names are standardized and can be found here: http://www.ensembl.org/info/website/upload/gff.html.
#'
#' @keywords datasets
"rat"

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hotspotPlot.r
\name{hotspotPlot}
\alias{hotspotPlot}
\title{Graphs hotspots of statistically significant peak activity.}
\usage{
hotspotPlot(totalpeaksfile, significantpeaksfile, organism, start, end, by)
}
\arguments{
\item{totalpeaksfile}{Filename in user's working directory (or full path to filename) containing all peaks.}

\item{significantpeaksfile}{Filename in user's working directory (or full path to filename) containing only significant peaks.}

\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{by}{Interval between consecutive extensions.}
}
\value{
Line plot showing the ratio of significant to total peaks at each interval across the genome.
}
\description{
Makes line plots showing the ratio of statistically significant peaks to the total number of peaks at each genomic interval (e.g., 0-500 bp upstream of every gene in the genome, 500-1000 bp upstream of every gene in the genome, etc.).
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
sigpeaks <- system.file("extdata", "significantpeaksfile.txt", package="geneXtendeR")
hotspotPlot(allpeaks, sigpeaks, rat, 0, 10000, 500)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barChart.r
\name{barChart}
\alias{barChart}
\title{Produces bar charts.}
\usage{
barChart(organism, start, end, by)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{by}{Interval between consecutive extensions.}
}
\value{
Creates bar charts.
}
\description{
Makes bar graphs showing the number of genes under peaks at various upstream extension levels.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
barChart(rat, 1000, 3000, 100)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allPeakLengths.r
\name{allPeakLengths}
\alias{allPeakLengths}
\title{Produces box-and-whisker plot showing distribution of peak lengths across a peaks input file.}
\usage{
allPeakLengths(filename)
}
\arguments{
\item{filename}{Name of peaks input file.}
}
\value{
Returns a box-and-whisker plot of peak length distribution across a peaks file.
}
\description{
Makes boxplots of all peak lengths (within a peaks input file) to show how lengths of individual peaks are distributed across the entire peak set.
}
\examples{
myfile <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
allPeakLengths(myfile)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peak_input_docs.r
\docType{data}
\name{samplepeaksinput}
\alias{samplepeaksinput}
\title{Sample peaks list to be used as input to geneXtendeR}
\format{A data frame with 25089 rows and 3 variables:
\describe{
\item{chr}{Chromosome number}
\item{start}{Peak start position [in units of base pairs]}
\item{end}{Peak end position [in units of base pairs]}
}}
\usage{
data(samplepeaksinput)
}
\value{
Demonstrates a sample peaks file used as input.
}
\description{
A dataset containing the chromosome number, start and stop positions
of ChIP-seq peaks along the Rattus norvegicus genome (rn6 assembly).
A dataset like this may be used as input to the peaksInput() command, 
which will sort the dataset by chromosome number and start position.
}
\examples{
head(samplepeaksinput)
tail(samplepeaksinput)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotWordFreq.r
\name{plotWordFreq}
\alias{plotWordFreq}
\title{Plots word frequencies found within gene ontology terms}
\usage{
plotWordFreq(organism, start, end, GOcategory, GOspecies, word_count)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{GOcategory}{Either BP, CC, or MF.}

\item{GOspecies}{Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).}

\item{word_count}{Number of top words to display}
}
\value{
A barplot comprised of words sorted by frequency of occurrence from gene ontology terms of either a BP, CC, or MF category.
}
\description{
Creates barplots of word frequencies from gene ontology terms derived from either biological process (BP), cellular compartment (CC), or molecular function (MF) of genes-under-peaks that are unique between two different upstream extension levels.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
library(tm)
library(SnowballC)
library(wordcloud)
library(RColorBrewer)
library(org.Rn.eg.db)
plotWordFreq(rat, 0, 500, BP, org.Rn.eg.db, 10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_lookup.r
\name{gene_lookup}
\alias{gene_lookup}
\title{Looks up specific gene and closest peaks}
\usage{
gene_lookup(organism, gene_name, n = 2, extension = NA, cutoff = Inf)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{gene_name}{Gene names or gene ids specified by user in a string form.}

\item{n}{Number of closest peaks located to `gene_name` on any given chromosome to be found. Default = 2}

\item{extension}{Desired upstream extension. If left unspecified, the latest geneXtender bed file will be chosen. If no extension is specified and no bed file can be found, a default extension of 500 is selected.}

\item{cutoff}{Optional arg to specify max bp distance to search around `gene_name`. Default = Inf}
}
\value{
A data.table with all peaks located within `n` peaks and `cutoff` bp distance away on every chromosome that contains `gene_name`.
}
\description{
Looks up closest peak to a specified gene on the peaks file (which has been preprocessed with the peaksInput() command) based on the latest .bed file accessed or for a specified extension.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
closest <- gene_lookup(rat, c("Vom2r3", "Vom2r5"), n = 7, extension = 1000)
closest

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneXtender.r
\name{.geneXtender}
\alias{.geneXtender}
\title{Function for formatting data to be called by C function.}
\usage{
.geneXtender(upstream, organism, ret = FALSE)
}
\arguments{
\item{upstream}{Extension upstream of each gene.}

\item{organism}{Object name assigned from readGFF() command.}

\item{ret}{Logical that designates if the output is written in R or only as a .bed file}
}
\value{
The gene coordinates extended by the designated upstream. In .bed file format.

A data.table formatted version of the data depending on the ret logical.
}
\description{
Formats genome-data based on upstream and organism for .C caller function. Not to be run by user.
}
\note{
Not to be run by the user
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distinct.r
\name{distinct}
\alias{distinct}
\title{Finds unique genes under peaks.}
\usage{
distinct(organism, start, end)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}
}
\value{
A data.table of unique genes located under peaks between two upstream extension levels.
}
\description{
Determines what genes directly under peaks are actually unique between two different upstream extension levels.
}
\details{
V1-V3 denote the chromosome/start/end positions of the peaks, V4-V6 denote the respective values of the genes, V7 is the gene ID (e.g., Ensembl ID), V8 is the gene name, and V9 is the distance of peak to nearest gene.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
distinct(rat, 2000, 3000)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeNetwork.r
\name{makeNetwork}
\alias{makeNetwork}
\title{Makes gene-GO networks}
\usage{
makeNetwork(organism, start, end, GOcategory, GOspecies)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{GOcategory}{Either BP, CC, or MF.}

\item{GOspecies}{Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).}
}
\value{
An interactive network of gene names linked to their respective gene ontology terms for either a BP, CC, or MF category.
}
\description{
Creates dynamic and interactive networks of genes linked to their respective gene ontology terms for each category (biological process (BP), cellular compartment (CC), molecular function (MF)) of genes-under-peaks that are unique between two different upstream extension levels.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
library(networkD3)
library(dplyr)
library(org.Rn.eg.db)
makeNetwork(rat, 0, 500, BP, org.Rn.eg.db)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peakLengthBoxplot.r
\name{peakLengthBoxplot}
\alias{peakLengthBoxplot}
\title{Produces box-and-whisker plot of peak lengths within any genomic interval.}
\usage{
peakLengthBoxplot(organism, start, end)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}
}
\value{
Creates boxplots showing how lengths of peaks are distributed within any given genomic interval.  Also, creates character vector composed of individual peak lengths.
}
\description{
Makes boxplots of peak lengths to show how lengths of individual peaks are distributed within any genomic interval (e.g., 0-500 bp upstream of nearest gene for all genes throughout the genome).
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
allpeaks <- system.file("extdata", "totalpeaksfile.txt", package="geneXtendeR")
peaksInput(allpeaks)
peakLengthBoxplot(rat, 0, 500)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeWordCloud.r
\name{makeWordCloud}
\alias{makeWordCloud}
\title{Makes word cloud from gene ontology terms}
\usage{
makeWordCloud(organism, start, end, GOcategory, GOspecies)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{GOcategory}{Either BP, CC, or MF.}

\item{GOspecies}{Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).}
}
\value{
A word cloud comprised of words gathered from gene ontology terms of either a BP, CC, or MF category.
}
\description{
Creates word cloud from gene ontology terms derived from either biological process (BP), cellular compartment (CC), or molecular function (MF) of genes-under-peaks that are unique between two different upstream extension levels.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
library(tm)
library(SnowballC)
library(wordcloud)
library(RColorBrewer)
library(org.Rn.eg.db)
makeWordCloud(rat, 0, 500, BP, org.Rn.eg.db)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate.r
\name{annotate}
\alias{annotate}
\title{Annotate peaks file.}
\usage{
annotate(organism, extension)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{extension}{Desired upstream extension.}
}
\value{
The gene coordinates are extended by `extension` at the 5-prime end, and by 500 bp at the 3-prime end.  The peaks file is then overlayed on these new gene coordinates, producing a file of peaks annotated with gene ID, gene name, and gene-to-peak genomic distance (in bp).  Distance is calculated between 5-prime end of gene and 3-prime end of peak.

A data.table formatted version of the annotated file for checking or further calculations.
}
\description{
Annotate a user's peaks file (which has been preprocessed with the peaksInput() command) with gene information based on optimally chosen geneXtendeR upstream extension file.  This command requires a preprocessed "peaks.txt" file (generated using peaksInput()) to be present in the user's working directory, otherwise the user is prompted to rerun the peaksInput() command in order to regenerate it.
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
annotate(rat, 2500)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meanPeakLength.r
\name{meanPeakLength}
\alias{meanPeakLength}
\title{Calculates mean (average) peak length for any genomic region.}
\usage{
meanPeakLength(organism, start, end)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}
}
\value{
A vector composed of a single number representing the average peak length found within a genomic interval.
}
\description{
Determines the average peak length of all peaks found within some genomic interval (e.g., 0-500 bp upstream of nearest gene for all genes throughout the genome).
}
\examples{
library(rtracklayer)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
sigpeaks <- system.file("extdata", "significantpeaksfile.txt", package="geneXtendeR")
peaksInput(sigpeaks)
meanPeakLength(rat, 0, 500)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffGO.R
\name{diffGO}
\alias{diffGO}
\title{Finds differential gene ontologies}
\usage{
diffGO(organism, start, end, GOcategory, GOspecies)
}
\arguments{
\item{organism}{Object name assigned from readGFF() command.}

\item{start}{Lower bound of upstream extension.}

\item{end}{Upper bound of upstream extension.}

\item{GOcategory}{Either BP, CC, or MF.}

\item{GOspecies}{Either org.Ag.eg.db (mosquito), org.Bt.eg.db (bovine), org.Ce.eg.db (worm), org.Cf.eg.db (canine), org.Dm.eg.db (fly), org.Dr.eg.db (zebrafish), org.Gg.eg.db (chicken), org.Hs.eg.db (human), org.Mm.eg.db (mouse), org.Mmu.eg.db (rhesus), org.Pt.eg.db (chimpanzee), org.Rn.eg.db (rat), org.Sc.sgd.db (yeast), org.Ss.eg.db (pig), or org.Xl.eg.db (frog).}
}
\value{
A data frame of gene symbol, gene ontology ID, and gene ontology term for either a BP, CC, or MF category.  This data frame displays the annotations of all unique genes (i.e., genes that are located under peaks between two upstream extension levels) with their respective gene ontology information.
}
\description{
Determines gene ontology terms for each category (biological process (BP), cellular compartment (CC), molecular function (MF)) of genes-under-peaks that are unique between two different upstream extension levels.
}
\examples{
library(rtracklayer)
library(org.Rn.eg.db)
rat <- readGFF("ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz")
fpath <- system.file("extdata", "somepeaksfile.txt", package="geneXtendeR")
peaksInput(fpath)
diffGO(rat, 0, 500, BP, org.Rn.eg.db)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rat.r
\docType{data}
\name{rat}
\alias{rat}
\title{Gene transfer format (GTF) file for rat (Rattus_norvegicus.Rnor_6.0.84)}
\format{A data frame with 748514 rows and 28 variables corresponding to the entries of a GTF file.  Column names are standardized and can be found here: http://www.ensembl.org/info/website/upload/gff.html.}
\usage{
data(rat)
}
\value{
Demonstrates a rat GTF file downloaded from: ftp://ftp.ensembl.org/pub/release-84/gtf/rattus_norvegicus/Rattus_norvegicus.Rnor_6.0.84.gtf.gz.
}
\description{
A dataset downloaded from Ensembl that contains the entries of a GTF file for Rattus norvegicus.
}
\examples{
head(rat)
tail(rat)

}
\keyword{datasets}
